bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/project/EditLocalProjectBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.project;

import java.io.Serializable;

import edu.kit.scc.webreg.entity.project.LocalProjectEntity;
import edu.kit.scc.webreg.service.project.LocalProjectService;
import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

@Named("admin.editLocalProjectBean")
@ViewScoped
public class EditLocalProjectBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private LocalProjectService service;
	
	private LocalProjectEntity entity;
	
	private Long projectId;

	public void preRenderView(ComponentSystemEvent ev) {
	}

	public String save() {
		entity = service.save(entity);
		return "show-local-project.xhtml?id=" + getEntity().getId() + "&faces-redirect=true"; 
	}
	
	public String cancel() {
		return "show-local-project.xhtml?id=" + getEntity().getId() + "&faces-redirect=true"; 
	}
	
	public Long getProjectId() {
		return projectId;
	}

	public void setProjectId(Long projectId) {
		this.projectId = projectId;
	}

	public LocalProjectEntity getEntity() {
		if (entity == null) {
			entity = service.fetch(projectId);
		}
		return entity;
	}

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/project/EditProjectAdminsBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.project;

import static edu.kit.scc.webreg.dao.ops.RqlExpressions.equal;
import static edu.kit.scc.webreg.entity.UserEntity_.userStatus;
import static edu.kit.scc.webreg.entity.UserStatus.ACTIVE;

import java.io.Serializable;
import java.util.List;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import org.primefaces.model.LazyDataModel;

import edu.kit.scc.webreg.entity.UserEntity;
import edu.kit.scc.webreg.entity.project.ExternalOidcProjectEntity;
import edu.kit.scc.webreg.entity.project.LocalProjectEntity;
import edu.kit.scc.webreg.entity.project.ProjectAdminType;
import edu.kit.scc.webreg.entity.project.ProjectEntity;
import edu.kit.scc.webreg.entity.project.ProjectIdentityAdminEntity;
import edu.kit.scc.webreg.entity.project.ProjectServiceEntity;
import edu.kit.scc.webreg.model.GenericLazyDataModelImpl;
import edu.kit.scc.webreg.service.UserService;
import edu.kit.scc.webreg.service.project.ProjectService;
import edu.kit.scc.webreg.session.SessionManager;

@Named
@ViewScoped
public class EditProjectAdminsBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private SessionManager session;

	@Inject
	private ProjectService service;

	@Inject
	private UserService userService;

	private ProjectEntity entity;
	private List<ProjectIdentityAdminEntity> adminList;
	private List<ProjectServiceEntity> serviceList;
	private LazyDataModel<UserEntity> allUserList;

	private Long projectId;

	private ProjectAdminType selectedAdminType;

	public void preRenderView(ComponentSystemEvent ev) {
		if (entity == null) {
			entity = service.fetch(projectId);
			selectedAdminType = ProjectAdminType.READ_WRITE;
		}
	}

	public void addAdmin(UserEntity user) {
		service.addAdminToProject(entity, user.getIdentity(), getSelectedAdminType(),
				"idty-" + session.getIdentityId());
		adminList = null;
	}

	public void removeAdmin(ProjectIdentityAdminEntity pia) {
		service.removeAdminFromProject(pia, "idty-" + session.getIdentityId());
		adminList = null;
	}

	public String cancel() {
		if (entity instanceof ExternalOidcProjectEntity)
			return "show-external-oidc-project.xhtml?faces-redirect=true&id=" + entity.getId();
		else if (entity instanceof LocalProjectEntity)
			return "show-local-project.xhtml?faces-redirect=true&id=" + entity.getId();
		else
			return "";
	}

	public ProjectEntity getEntity() {
		return entity;
	}

	public void setEntity(ProjectEntity entity) {
		this.entity = entity;
	}

	public Long getProjectId() {
		return projectId;
	}

	public void setProjectId(Long projectId) {
		this.projectId = projectId;
	}

	public List<ProjectIdentityAdminEntity> getAdminList() {
		if (adminList == null) {
			adminList = service.findAdminsForProject(entity);
		}
		return adminList;
	}

	public List<ProjectServiceEntity> getServiceList() {
		if (serviceList == null) {
			serviceList = service.findServicesForProject(entity);
		}
		return serviceList;
	}

	public LazyDataModel<UserEntity> getAllUserList() {
		if (allUserList == null) {
			allUserList = new GenericLazyDataModelImpl<UserEntity, UserService>(userService, equal(userStatus, ACTIVE));
		}
		return allUserList;
	}

	public ProjectAdminType getSelectedAdminType() {
		return selectedAdminType;
	}

	public void setSelectedAdminType(ProjectAdminType selectedAdminType) {
		this.selectedAdminType = selectedAdminType;
	}

	public ProjectAdminType[] getAdminTypes() {
		return ProjectAdminType.values();
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/project/ListProjectBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.project;

import java.io.Serializable;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import org.primefaces.model.LazyDataModel;
import org.slf4j.Logger;

import edu.kit.scc.webreg.entity.project.ProjectEntity;
import edu.kit.scc.webreg.model.GenericLazyDataModelImpl;
import edu.kit.scc.webreg.service.project.ProjectService;

@Named
@ViewScoped
public class ListProjectBean implements Serializable {

	private static final long serialVersionUID = 1L;

    @Inject
    private Logger logger;
    
    @Inject
    private ProjectService service;

	private LazyDataModel<ProjectEntity> list;

	public void preRenderView(ComponentSystemEvent ev) {
		if (list == null) {
			list = new GenericLazyDataModelImpl<ProjectEntity, ProjectService>(service);
		}
	}

    public LazyDataModel<ProjectEntity> getProjectEntityList() {
   		return list;
    }
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/project/ShowExternalOidcProjectBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.project;

import java.io.Serializable;
import java.util.List;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.project.ExternalOidcProjectEntity;
import edu.kit.scc.webreg.entity.project.ExternalOidcProjectEntity_;
import edu.kit.scc.webreg.entity.project.ProjectIdentityAdminEntity;
import edu.kit.scc.webreg.entity.project.ProjectMembershipEntity;
import edu.kit.scc.webreg.service.project.ExternalOidcProjectService;
import edu.kit.scc.webreg.service.project.ProjectService;

@Named
@ViewScoped
public class ShowExternalOidcProjectBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private ExternalOidcProjectService service;

	@Inject
	private ProjectService projectService;

	private ExternalOidcProjectEntity entity;
	private List<ProjectMembershipEntity> memberList;
	private List<ProjectIdentityAdminEntity> adminList;

	private Long id;

	public void preRenderView(ComponentSystemEvent ev) {
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public ExternalOidcProjectEntity getEntity() {
		if (entity == null) {
			entity = service.findByIdWithAttrs(id, ExternalOidcProjectEntity_.projectServices);
		}

		return entity;
	}

	public void setEntity(ExternalOidcProjectEntity entity) {
		this.entity = entity;
	}

	public List<ProjectMembershipEntity> getMemberList() {
		if (memberList == null) {
			memberList = projectService.findMembersForProject(getEntity());
		}
		return memberList;
	}

	public List<ProjectIdentityAdminEntity> getAdminList() {
		if (adminList == null) {
			adminList = projectService.findAdminsForProject(getEntity());
		}
		return adminList;
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/project/ShowLocalProjectBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.project;

import java.io.Serializable;
import java.util.List;

import edu.kit.scc.webreg.entity.project.LocalProjectEntity;
import edu.kit.scc.webreg.entity.project.LocalProjectEntity_;
import edu.kit.scc.webreg.entity.project.ProjectIdentityAdminEntity;
import edu.kit.scc.webreg.entity.project.ProjectMembershipEntity;
import edu.kit.scc.webreg.service.project.LocalProjectService;
import edu.kit.scc.webreg.service.project.ProjectService;
import edu.kit.scc.webreg.session.SessionManager;
import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

@Named("admin.showLocalProjectBean")
@ViewScoped
public class ShowLocalProjectBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private LocalProjectService service;

	@Inject
	private ProjectService projectService;

	@Inject
	private SessionManager session;
	
	private LocalProjectEntity entity;
	private List<ProjectMembershipEntity> memberList;
	private List<ProjectIdentityAdminEntity> adminList;

	private Long id;

	public void preRenderView(ComponentSystemEvent ev) {
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public void syncAllMembersToGroup() {
		projectService.syncAllMembersToGroup(getEntity(), "idty-" + session.getIdentityId());
	}

	public void triggerGroupUpdate() {
		projectService.triggerGroupUpdate(getEntity(), "idty-" + session.getIdentityId());
	}
	
	public LocalProjectEntity getEntity() {
		if (entity == null) {
			entity = service.findByIdWithAttrs(id, LocalProjectEntity_.projectServices);
		}

		return entity;
	}

	public void setEntity(LocalProjectEntity entity) {
		this.entity = entity;
	}

	public List<ProjectMembershipEntity> getMemberList() {
		if (memberList == null) {
			memberList = projectService.findMembersForProject(getEntity());
		}
		return memberList;
	}

	public List<ProjectIdentityAdminEntity> getAdminList() {
		if (adminList == null) {
			adminList = projectService.findAdminsForProject(getEntity());
		}
		return adminList;
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/project/EditClientProjectBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Haykuhi Musheghyan
 ******************************************************************************/
package edu.kit.scc.webreg.bean.project;

import java.io.IOException;
import java.io.Serializable;
import edu.kit.scc.webreg.entity.project.LocalProjectEntity;
import edu.kit.scc.webreg.entity.project.ProjectEntity;
import edu.kit.scc.webreg.service.project.LocalProjectService;
import edu.kit.scc.webreg.util.ViewIds;
import jakarta.faces.context.FacesContext;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;
import jakarta.persistence.Column;
import lombok.Getter;
import lombok.Setter;
import edu.kit.scc.webreg.util.FacesMessageGenerator;

@Named
@ViewScoped
public class EditClientProjectBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private LocalProjectService service;

	@Inject
	private FacesMessageGenerator messageGenerator;

	private LocalProjectEntity entity;

	@Getter
	@Setter
	private Long projectId;

	public void save() {

		Column projectEntityDbColumnAnnotation = null;

		try {
			projectEntityDbColumnAnnotation = ProjectEntity.class.getDeclaredField("name")
					.getDeclaredAnnotation(Column.class);

		} catch (NoSuchFieldException | SecurityException e) {
			messageGenerator.addErrorMessage("Ein Fehler ist aufgetreten", e.toString());
			return;
		}

		if (entity.getName().length() > projectEntityDbColumnAnnotation.length()) {
			messageGenerator.addResolvedErrorMessage("failure", "project.local_project.create_edit_name_length_details",
					true);
			return;
		}
		
		entity = service.save(entity);

		if (entity != null) {
			messageGenerator.addResolvedInfoMessage("success", "project.local_project.create_edit_name_success_detail",
					true);
		}

		try {
			FacesContext.getCurrentInstance().getExternalContext()
					.redirect(ViewIds.PROJECT_LOCAL_SHOW + "?id=" + entity.getId());
		} catch (IOException e) {
			messageGenerator.addErrorMessage("Ein Fehler ist aufgetreten", e.toString());
		}

	}

	public void cancel() {
		try {
			FacesContext.getCurrentInstance().getExternalContext().redirect(ViewIds.PROJECT_LOCAL_INDEX);
		} catch (IOException e) {
			messageGenerator.addErrorMessage("Ein Fehler ist aufgetreten", e.toString());
		}

	}

	public LocalProjectEntity getEntity() {
		if (entity == null) {
			entity = service.fetch(projectId);
		}
		return entity;
	}

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/project/ListPublicProjectsIndexBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.project;

import static edu.kit.scc.webreg.dao.ops.PaginateBy.unlimited;
import static edu.kit.scc.webreg.dao.ops.RqlExpressions.and;
import static edu.kit.scc.webreg.dao.ops.RqlExpressions.equal;
import static edu.kit.scc.webreg.dao.ops.RqlExpressions.notEqual;
import static edu.kit.scc.webreg.dao.ops.RqlExpressions.or;
import static edu.kit.scc.webreg.dao.ops.SortBy.ascendingBy;

import java.io.Serializable;
import java.util.List;

import edu.kit.scc.webreg.dao.ops.RqlExpressions;
import edu.kit.scc.webreg.entity.project.ProjectEntity;
import edu.kit.scc.webreg.entity.project.ProjectEntity_;
import edu.kit.scc.webreg.entity.project.ProjectStatus;
import edu.kit.scc.webreg.service.project.ProjectService;
import edu.kit.scc.webreg.session.SessionManager;
import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

@Named
@ViewScoped
public class ListPublicProjectsIndexBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private SessionManager session;

	@Inject
	private ProjectService projectService;

	private List<ProjectEntity> projectList;

	public void preRenderView(ComponentSystemEvent ev) {

	}

	public List<ProjectEntity> getProjectList() {
		if (projectList == null) {
			projectList = projectService.findAll(unlimited(), ascendingBy(ProjectEntity_.name),
					and(equal(ProjectEntity_.published, true),RqlExpressions.isNull(ProjectEntity_.projectStatus)));
		}
		return projectList;
	}

}

bwreg-webapp/src/main/webapp/project/edit-local-project-admins.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:bw="http://www.scc.kit.edu/bwfacelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:of="http://omnifaces.org/functions">
<head>
<title></title>
</head>
<body>
<f:view>
	<f:metadata>
		<f:viewParam name="id" value="#{userEditLocalProjectAdminsBean.projectId}"/>
		<f:event type="jakarta.faces.event.PreRenderViewEvent"
            listener="#{userEditLocalProjectAdminsBean.preRenderView}" />
	</f:metadata>

<ui:composition template="/template/default.xhtml">
	<ui:param name="title" value="#{messages.title}"/>

	<ui:define name="content">
	<h:form id="form" styleClass="full">

		<h2><h:outputText value="#{messages['project.edit_admins']}: #{userEditLocalProjectAdminsBean.entity.name}"/></h2>

		<p:messages id="messageBox" showDetail="true" />

		<h:panelGrid id="baseData" style="margin-top:1em;" columns="2" layout="flex" columnClasses="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">
			
			<h:outputText value="#{messages.id}:"/>
			<h:outputText value="#{userEditLocalProjectAdminsBean.entity.id}"/>
			
			<h:outputText value="#{messages.name}:"/>
			<h:outputText value="#{userEditLocalProjectAdminsBean.entity.name}"/>
			
		</h:panelGrid>

		<h6 style="margin-top: 1em;"><h:outputText value="#{messages['project.edit_admins.make_member_to_admin']}"/></h6>
		<div class="text"><h:outputText value="#{messages['project.edit_admins.make_member_to_admin_text']}"/></div>
		<p:outputPanel>
	        <p:selectOneMenu value="#{userEditLocalProjectAdminsBean.selectedAdminType}">
            	<f:selectItems value="#{userEditLocalProjectAdminsBean.adminTypes}" 
            		var="et" itemLabel="#{et}" itemValue="#{et}"/>
            </p:selectOneMenu>
		</p:outputPanel>
		
		<p:dataTable id="dataTableAllMemberList" var="member" value="#{userEditLocalProjectAdminsBean.memberList}" paginator="true"
					lazy="true" rows="15"
					style="width:auto; font-size: 1.2rem;">
			<p:column sortBy="#{member.prefUser.id}" style="width:128px;">
				<f:facet name="header">
					<h:outputText value="#{messages.id}" />
				</f:facet>
				<h:outputText value="#{member.prefUser.id}" />
			</p:column>
			<p:column sortBy="#{member.prefUser.surName}" filterBy="#{member.prefUser.surName}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.sur_name}" />
				</f:facet>
				<h:outputText value="#{member.prefUser.surName}" />
			</p:column>			
			<p:column sortBy="#{member.prefUser.givenName}" filterBy="#{member.prefUser.givenName}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.given_name}" />
				</f:facet>
				<h:outputText value="#{member.prefUser.givenName}" />
			</p:column>			
			<p:column sortBy="#{member.primaryEmail}" filterBy="#{member.primaryEmail}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.email}" />
				</f:facet>
				<h:outputText value="#{member.primaryEmail != null ? member.primaryEmail.emailAddress : 'nicht gesetzt'}" />
			</p:column>
			<p:column sortBy="#{member.prefUser.eppn}" filterBy="#{member.prefUser.eppn}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.account}" />
				</f:facet>
				<h:outputText value="#{member.prefUser.eppn}" />
			</p:column>
			<p:column sortBy="#{member.prefUser.userStatus}" style="width:96px;">
				<f:facet name="header">
					<h:outputText value="#{messages.status}" />
				</f:facet>
				<h:outputText value="#{member.prefUser.userStatus}" />
			</p:column>			
			<p:column>
				<p:commandLink action="#{userEditLocalProjectAdminsBean.addAdmin(member)}" title="#{messages.add}"
							update=":form:dataTableAdmins" class="button icon">
							 <i class="fa fa-fw fa-plus" style="font-size: 1em;"></i>
				</p:commandLink>
			</p:column>	
		</p:dataTable>

		<h6 style="margin-top: 1em;"><h:outputText value="#{messages['project.edit_admins.remove_admin']}"/></h6>
		<div class="text"><h:outputText value="#{messages['project.edit_admins.remove_admin_text']}"/></div>
		<p:dataTable id="dataTableAdmins" var="a" value="#{userEditLocalProjectAdminsBean.adminList}" paginator="true"
					rows="15"
					style="width:auto; font-size: 1.2rem;">
			<p:column>
				<f:facet name="header">
					<h:outputText value="#{messages.id}" />
				</f:facet>
				<h:outputText value="#{a.identity.id}" />
			</p:column>			
			<p:column sortBy="#{a.identity.prefUser.surName}" filterBy="#{a.identity.prefUser.surName}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.sur_name}" />
				</f:facet>
				<h:outputText value="#{a.identity.prefUser.surName}" />
			</p:column>			
			<p:column sortBy="#{a.identity.prefUser.givenName}" filterBy="#{a.identity.prefUser.givenName}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.given_name}" />
				</f:facet>
				<h:outputText value="#{a.identity.prefUser.givenName}" />
			</p:column>	
			<p:column sortBy="#{a.identity.primaryEmail.emailAddress}" filterBy="#{a.identity.primaryEmail.emailAddress}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.email}" />
				</f:facet>
				<h:outputText value="#{a.identity.primaryEmail.emailAddress}" />
			</p:column>			
			<p:column sortBy="#{a.identity.prefUser.eppn}" filterBy="#{a.identity.prefUser.eppn}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.account}" />
				</f:facet>
				<h:outputText value="#{a.identity.prefUser.eppn}" />
			</p:column>			
			<p:column>
				<f:facet name="header">
					<h:outputText value="#{messages.type}" />
				</f:facet>
				<h:outputText value="#{a.type}" />
			</p:column>			
			<p:column>
				<p:commandLink action="#{userEditLocalProjectAdminsBean.removeAdmin(a)}"
							update=":form:dataTableAdmins :form:messageBox" class="button icon" title="#{messages.remove}">
							    <i class="fa fa-fw fa-trash" style="font-size: 1em;"></i>
				</p:commandLink>
						
			</p:column>	
		</p:dataTable>
		
		<div class="text" style="margin-top: 0.4em;">
			<h:panelGroup rendered="#{userEditLocalProjectAdminsBean.entity.class.simpleName == 'LocalProjectEntity'}">
				<a href="show-local-project.xhtml?id=#{userEditLocalProjectAdminsBean.entity.id}"><h:outputText value="#{messages.back}"/></a>
			</h:panelGroup>
			<h:panelGroup rendered="#{userEditLocalProjectAdminsBean.entity.class.simpleName == 'AttributeSourceProjectEntity'}">
				<a href="show-as-project.xhtml?id=#{userEditLocalProjectAdminsBean.entity.id}"><h:outputText value="#{messages.back}"/></a>
			</h:panelGroup>		
		</div>	
		
	</h:form>

	</ui:define>
</ui:composition>
</f:view>		
</body>
</html>